/* net client test
 * Compile: cc -o netc -lsocket -lnsl netc.c
 * Usage: netc [[<port number>] [<message>]]
 * Sends message "hello jim"
 *
 * DJA, PRESTO/SST, 28 fevrier 97
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/un.h>
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/uio.h>
#include <fcntl.h>
 
extern int errno;
#include <errno.h>

/* for solaris */ 
#include <stropts.h>
#include <sys/conf.h>

main(int argc,char **argv) {
  int sock,status,result;
  struct sockaddr_in sockaddr;
  char *host;
  char localhost[MAXHOSTNAMELEN];
  struct hostent *hostent, _hostent;
  int hostaddr, hostaddrPtr[2];
  int port;
  char *msg;
  char *msg_def="hello jim";

  msg = (char *)malloc(256);

  if (argc>1) { 
    if (argc>3) {
      printf("usage is netc [[<port number>] [<message>]]\n");
      exit(1);
    }
    if (argc>1) {
      port = atoi(argv[1]);
    }
    
    if (argc==3) {
      strcpy(msg,argv[2]);
    } else {
      strcpy(msg,msg_def);
    }
  } else {
    port=2030;
    strcpy(msg,msg_def);
  }

  printf("Will attempt to connect to port %d\n", port);

  gethostname(localhost, MAXHOSTNAMELEN);
  host=localhost;
  hostent = gethostbyname(host);

  if (hostent == NULL) {
    if (strlen(host) == 0) {
      memset(&hostaddr, 0, sizeof(hostaddr));
    } else {
      hostaddr = inet_addr(host);
      if (hostaddr == -1) {
	return -1;
      }
    }
    _hostent.h_addr_list = (char **) hostaddrPtr;
    _hostent.h_addr_list[0] = (char *) &hostaddr;
    _hostent.h_length = sizeof(hostaddr);
    _hostent.h_addr_list[1] = NULL;
    _hostent.h_addrtype = AF_INET;
    hostent = &_hostent;
  }

  sock = socket(PF_INET, SOCK_STREAM, 0);
  if (sock<0) { printf("Cannot create socket.\n"); exit(1); }
  memset((char *) &sockaddr, 0, sizeof(sockaddr));
  sockaddr.sin_family = AF_INET;
  memcpy((char *) &(sockaddr.sin_addr.s_addr),
	 (char *) hostent->h_addr_list[0],
	 (size_t) hostent->h_length);
  sockaddr.sin_port = htons(port);

  status = connect(sock,(struct sockaddr *)&sockaddr, sizeof(sockaddr));
  if (status < 0) {
    close(sock);
    printf("Failed to connect socket: %d\n",status);
    exit(1);
  }
  
  result = send(sock,msg,strlen(msg),0);
  if (result<0) {
    printf("send failed with errno of %d\n", errno);
  } else {
    printf("Successfully sent message (%d bytes).\n",result);
  }
  close(sock);
}
